<?php
if (!class_exists('RedsysAPI')) require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . 'TpvVirtual' . DIRECTORY_SEPARATOR . 'RedsysAPI.php');
if (!class_exists('TpvVirtualAPI')) require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . 'TpvVirtual' . DIRECTORY_SEPARATOR . 'TpvVirtualAPI.php');
chdir('../../../../');
require('includes/application_top.php');

function obtenerDatosOperacionTpvVirtual($ds_order)
{

    $tpvVirtuaOperaciones = array();

    if ($ds_order > 0) {

        $consulta = "SELECT so.id_order,
                            so.merchant_order, 
                            so.merchant_code, 
                            so.importe_cobrado, 
                            so.importe_devuelto, 
                            so.id_terminal, 
                            so.moneda, 
                            so.clave_encriptacion, 
                            so.tipo_pago, 
                            so.id_estado, 
                            seo.id_estado_ecommerce
            FROM NCP_TPV_VIRTUAL_OPERACIONES so
            JOIN NCP_TPV_VIRTUAL_ESTADO_OPERACION seo ON seo.id_estado = so.id_estado
            WHERE so.merchant_order = " . $ds_order . " ORDER BY id_order  ";

        $query = tep_db_query($consulta);
        $tpvVirtuaOperaciones = tep_db_fetch_array($query);
    }

    return $tpvVirtuaOperaciones;
}

function obtenerEstadoEcommerce($estadoTpvVirtualNCP)
{

    $order_status_id = DEFAULT_ORDERS_STATUS_ID;

    //Obtenemos el estado que hay en el CMS que equivale a la referencia que nosotros tenemos para la operación.
    $idEstado_query = tep_db_query("SELECT id_estado_ecommerce FROM NCP_TPV_VIRTUAL_ESTADO_OPERACION WHERE id_estado =" . $estadoTpvVirtualNCP);
    $idEstado = tep_db_fetch_array($idEstado_query);

    if (count($idEstado) > 0) {
        $order_status_id = $idEstado['id_estado_ecommerce'];
    }

    return $order_status_id;
}

function actualizarHistorialOrden($oID, $status)
{


    tep_db_query("update " . TABLE_ORDERS . " set orders_status = '" . tep_db_input($status) . "', last_modified = now() where orders_id = '" . (int)$oID . "'");
    tep_db_query("insert into " . TABLE_ORDERS_STATUS_HISTORY . " (orders_id, orders_status_id, date_added, customer_notified, comments) values ('" . (int)$oID . "', '" . tep_db_input($status) . "', now(), '" . tep_db_input($customer_notified) . "', '" . tep_db_input($comments) . "')");

    $order_updated = true;


    return $order_updated;
}

// Cambiamos solo el estado de la orden.
function actualizaEstadoOperacion($order_id, $ds_order, $estadoTpvVirtualNCP)
{

    $order_status_id = obtenerEstadoEcommerce($estadoTpvVirtualNCP);
    tep_db_query('UPDATE NCP_TPV_VIRTUAL_OPERACIONES SET id_estado=' . $estadoTpvVirtualNCP . ' WHERE id_order = ' . $order_id);
    actualizarHistorialOrden($order_id, $order_status_id);
}

//Si es una devolucion es diferente ya que tenemos que actualizar el importe devuelto.
function actualizaEstadoDevolucion($order_id, $ds_order, $importe_devuelto)
{

    $importeDevueltoAnterior = 0;
    $importeCobrado = 0;
    $estadoTpvVirtualNCP = TpvVirtualAPI::DEVOLUCION_COMPLETA;
    $resultado_query = tep_db_query('SELECT importe_cobrado, importe_devuelto FROM NCP_TPV_VIRTUAL_OPERACIONES WHERE id_order = ' . $order_id);
    $resultado = tep_db_fetch_array($resultado_query);

    if (count($resultado) > 0) {
        $importeDevueltoAnterior = $resultado['importe_devuelto'];
        $importeCobrado = $resultado['importe_cobrado'];
    }

    $importe_devuelto = $importe_devuelto + $importeDevueltoAnterior;

    //Precisión de la comparación
    $epsilon = 0.001;

    //Si el importe devuelto es igual al total, será una devolución completa, en caso contrario será una devolución parcial.
    if (abs(floatval($importe_devuelto) - floatval($importeCobrado)) < $epsilon)
        $estadoTpvVirtualNCP = TpvVirtualAPI::DEVOLUCION_COMPLETA;
    else
        $estadoTpvVirtualNCP = TpvVirtualAPI::DEVOLUCION_PARCIAL;

    $order_status_id = obtenerEstadoEcommerce($estadoTpvVirtualNCP);
    tep_db_query('UPDATE NCP_TPV_VIRTUAL_OPERACIONES SET id_estado=' . (int)$estadoTpvVirtualNCP . ', importe_devuelto=' . $importe_devuelto . '  WHERE id_order = ' . $order_id);
    actualizarHistorialOrden($order_id, $order_status_id);
}

$ds_amount = "";
$ds_currency = "";
$ds_order = "";
$ds_merchantcode = "";
$ds_terminal = "";
$ds_response = "";
$ds_transactiontype = "";
$ds_date = "";
$ds_hour = "";
$ds_AuthorisationCode = "";
$ds_ErrorCode = "";
$ds_SignatureVersion = "";
$ds_Signature = "";
$ds_MerchantParameters = "";


if (isset($_POST) && count($_POST) > 0) {

    if (isset($_POST['Ds_SignatureVersion']))
        $ds_SignatureVersion = $_POST["Ds_SignatureVersion"];

    if (isset($_POST['Ds_MerchantParameters']))
        $ds_MerchantParameters = $_POST["Ds_MerchantParameters"];

    if (isset($_POST['Ds_Signature']))
        $ds_Signature = $_POST["Ds_Signature"];
} else if (isset($_GET) && count($_GET) > 0) {

    if (isset($_GET['Ds_SignatureVersion']))
        $ds_SignatureVersion = $_GET["Ds_SignatureVersion"];

    if (isset($_GET['Ds_MerchantParameters']))
        $ds_MerchantParameters = $_GET["Ds_MerchantParameters"];

    if (isset($_GET['Ds_Signature']))
        $ds_Signature = $_GET["Ds_Signature"];

}


//Si no está alguno de los parámetros necesarios damos el mensaje de error.
if (!isset($ds_MerchantParameters) || $ds_MerchantParameters == "" ||
    !isset($ds_SignatureVersion) || $ds_SignatureVersion == "" ||
    !isset($ds_Signature) || $ds_Signature == "") {
    tep_redirect('tpv_virtual_ko.php?Ds_Response="Sin Respuesta"');
} else {

    $miObj = new RedsysAPI;
    $decodec = $miObj->decodeMerchantParameters($ds_MerchantParameters);

    //Decodificamos los los parámetros para obtenerlos.
    $miObj->stringToArray($decodec);

    $ds_amount = $miObj->getParameter("Ds_Amount");
    $ds_order = $miObj->getParameter("Ds_Order");
    $ds_merchantcode = $miObj->getParameter("Ds_MerchantCode");
    $ds_currency = $miObj->getParameter("Ds_Currency");
    $ds_transactiontype = $miObj->getParameter("Ds_TransactionType");
    $ds_terminal = $miObj->getParameter("Ds_Terminal");
    $ds_response = $miObj->getParameter('Ds_Response');
    $ds_AuthorisationCode = $miObj->getParameter('Ds_AuthorisationCode');
    $ds_date = $miObj->getParameter('Ds_Date');
    $ds_hour = $miObj->getParameter('Ds_Hour');

    //Obtenemos el identificador de la orden para actualizar su estado
    $datosOperacion = obtenerDatosOperacionTpvVirtual($ds_order);
    $order_id = $datosOperacion['id_order'];

    $codMoneda = TpvVirtualAPI::inversaObtenerCodMonedaISO($ds_currency);
    //$stringMoneda = 'MODULE_PAYMENT_TPV_VIRTUAL_CLAVE_' . $codMoneda;
    $stringMoneda = 'MODULE_PAYMENT_TPV_VIRTUAL_CLAVE1';
    $claveEncriptacion = constant($stringMoneda);
    $firma = $miObj->createMerchantSignatureNotif($claveEncriptacion, $ds_MerchantParameters);

    //Si la firma no es correcta procedemos a registrar
    if (strcmp($firma, $ds_Signature) !== 0) {
        tep_redirect('tpv_virtual_ko.php?=Ds_Signature="' . $firma . "-" . $ds_Signature . '"&Ds_Response=' . $ds_response . '&oID=' . $order_id);
    } else {

        if ($ds_Response < 101 || $ds_Response == 900 || $ds_Response == 400 || $ds_Response == 481 || $ds_Response == 500 || $ds_Response == 9929) {

            $importe = number_format($ds_amount / 100, 4, '.', '');

            switch (strtoupper($ds_transactiontype)) {
                case TpvVirtualAPI::CONFIRMACION_PREAUTORIZACION:
                    $estadoTpvVirtualNCP = TpvVirtualAPI::PREAUTORIZACION_CONFIRMADA;
                    break;
                case TpvVirtualAPI::DEVOLUCION_PARCIAL_TOTAL:
                    break;
                case TpvVirtualAPI::ANULACION_PREAUTORIZACION:
                    $estadoTpvVirtualNCP = TpvVirtualAPI::PREAUTORIZACION_ANULADA;
                    break;
                case TpvVirtualAPI::CONFIRMACION_PREAUTORIZACION_DIFERIDA:
                    $estadoTpvVirtualNCP = TpvVirtualAPI::PREAUTORIZACION_CONFIRMADA;
                    break;
                case TpvVirtualAPI::ANULACION_PREAUTORIZACION_DIFERIDA:
                    $estadoTpvVirtualNCP = TpvVirtualAPI::PREAUTORIZACION_ANULADA;
                    break;
                case TpvVirtualAPI::CONFIRMACION_AUTENTICACION:
                    $estadoTpvVirtualNCP = TpvVirtualAPI::AUTENTICACION_CONFIRMADA;
                    break;
                default:
                    break;
            }

            if (strtoupper($ds_transactiontype) == TpvVirtualAPI::DEVOLUCION_PARCIAL_TOTAL)
                actualizaEstadoDevolucion((int)$order_id, $ds_order, $importe);
            else {
                actualizaEstadoOperacion((int)$order_id, $ds_order, $estadoTpvVirtualNCP);
            }

            tep_redirect('tpv_virtual_transactions.php?oID=' . $order_id);
        } else {
            tep_redirect('tpv_virtual_ko.php?=Ds_Signature="' . $firma . "-" . $ds_Signature . '"&Ds_Response=' . $ds_response . '&oID=' . $order_id);
        }
    }

}
?>