<?php

if (!class_exists('Tarjetas')) require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . 'TpvVirtual' . DIRECTORY_SEPARATOR . 'Tarjetas.php');
chdir('../../../../');
include('includes/application_top.php');

$borradoOK = false;
$esJsonp = false;
$msgOut = "";

try {
    //Comprobamos si es una peticion jsonP
    if (isset($_GET['customer']) && isset($_GET['tarjetaSeleccionada']) && isset($_GET['callback'])) {
        $esJsonp = true;
        $data = array('customer' => $_GET['customer'], 'tarjetaSeleccionada' => $_GET['tarjetaSeleccionada']);

    } else {
        $data = json_decode(file_get_contents('php://input'), true);
    }


    if ($data != null && count($data) == 2) {
        Tarjetas::borraTarjetaCliente($data["customer"], $data["tarjetaSeleccionada"]);
        $borradoOK = true;
    }


} catch (Exception $ex) {
    $msgOut = $ex->getMessage();
}


$arr = array('BORRADO' => $borradoOK, 'MSG' => $msgOut);
$msgOut = json_encode($arr, JSON_FORCE_OBJECT);


if ($esJsonp) {
    header_remove();
    header("content-type: text/javascript");
    echo $_GET['callback'] . '(' . $msgOut . ');';
} else {
    header_remove();
    header('Content-Type: application/json');
    echo $msgOut;
}
