<?php

if (!class_exists('RedsysAPI')) require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . 'TpvVirtual' . DIRECTORY_SEPARATOR . 'RedsysAPI.php');
if (!class_exists('TpvVirtualAPI')) require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . 'TpvVirtual' . DIRECTORY_SEPARATOR . 'TpvVirtualAPI.php');
if (!class_exists('Tarjetas')) require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . 'TpvVirtual' . DIRECTORY_SEPARATOR . 'Tarjetas.php');

class tpvbbva
{
    var $code, $title, $description, $enabled;

// class constructor
    function tpvbbva()
    {
        global $order, $currency;
        $this->signature = 'tpvbbva|1.1';
        $this->code = 'tpvbbva';
        $this->title = utf8_encode(MODULE_PAYMENT_TPV_VIRTUAL_TEXT_TITLE);
        $this->description = utf8_encode(MODULE_PAYMENT_TPV_VIRTUAL_TEXT_DESCRIPTION);
        $this->enabled = ((MODULE_PAYMENT_TPV_VIRTUAL_ESTADO == 'True') ? true : false);
        $this->order_status;
        $this->sort_order = 0;

        if ($this->enabled = true) {

            if (strcmp(MODULE_PAYMENT_TPV_VIRTUAL_ENTORNO, 'Test') == 0) {
                $this->form_action_url = MODULE_PAYMENT_TPV_VIRTUAL_URL_PRUEBAS;
            } else {
                $this->form_action_url = MODULE_PAYMENT_TPV_VIRTUAL_URL;
            }

            //Si no estan definidas el modulo se desactivará-
            if ((!defined('MODULE_PAYMENT_TPV_VIRTUAL_MERCHANT_CURRENCY1') || !strlen(MODULE_PAYMENT_TPV_VIRTUAL_MERCHANT_CURRENCY1)) ||
                (!defined('MODULE_PAYMENT_TPV_VIRTUAL_TERMINAL1') || !strlen(MODULE_PAYMENT_TPV_VIRTUAL_TERMINAL1)) ||
                (!defined('MODULE_PAYMENT_TPV_VIRTUAL_CLAVE1') || !strlen(MODULE_PAYMENT_TPV_VIRTUAL_CLAVE1)) ||
                (!defined('MODULE_PAYMENT_TPV_VIRTUAL_CODIGO_FUC') || !strlen(MODULE_PAYMENT_TPV_VIRTUAL_CODIGO_FUC))
            ) {
                $this->enabled = false;
            }

            //Si la moneda seleccionada en la tienda no es la misma que hay configurada en el TPV Virtual tampoco lo habilitamos.
            if (TpvVirtualAPI::obtenerCodMonedaISO($currency) != TpvVirtualAPI::obtenerCodMoneadaPorNombre(constant('MODULE_PAYMENT_TPV_VIRTUAL_MERCHANT_CURRENCY1'))) {
                $this->enabled = false;
            }
        }
    }

    function update_status()
    {
        global $order;


        if (($this->enabled == true) && ((int)MODULE_PAYMENT_TPV_VIRTUAL_ZONE > 0)) {
            $check_flag = false;
            $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_TPV_VIRTUAL_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");

            while ($check = tep_db_fetch_array($check_query)) {
                if ($check['zone_id'] < 1) {
                    $check_flag = true;
                    break;
                } elseif ($check['zone_id'] == $order->billing['zone_id']) {
                    $check_flag = true;
                    break;
                }
            }

            if ($check_flag == false) {
                $this->enabled = false;
            }
        }
    }    /*

    * Método para incluir javascript en la validación del selector del método de pago.
     */
    function javascript_validation()
    {
        return false;
    }

    private function ObtenerPlantilla1()
    {
        $template1 = '<div id="ncp_tpv_virtual" style="border: 1px solid #d6d4d4;    border-radius: 10px;padding: 15px;width: 600px;">
                        <div style="display:inline-block;width: 100%">
                            <div id="encabezado" style="float: left;width: 100%; font-weight: bold;padding-bottom: 20px;padding-top:20px ">
                                <img src="images/modules/payment/tpvbbva/logo.png" style="border: 0px; vertical-align: text-bottom; margin-right: 10px; float:left;"/><br><br>
                                Pago con tarjeta de credito a traves del TPV Virtual.
                            </div>
                            <div id="opciones">
                                <table style="width: 75%;">
                                    <tr>
                                        <td style="padding-bottom: 0px;"><strong>NO</strong> recordar la tarjeta para futuros pagos</td>
                                        <td style="padding-bottom: 0px;text-align: center">
                                            <input type="radio" name="tarjetaSeleccionadaForm" id="tarjetaSeleccionadaForm" value="' . TpvVirtualAPI::NO_RECORDAR . '" checked="checked">
                                        </td>
                                    </tr>
                                    <tr>
                                        <td style="padding-bottom: 0px;">Recordar la tarjeta para futuros pagos</td>
                                        <td style="padding-bottom: 0px;text-align: center">
                                            <input type="radio" name="tarjetaSeleccionadaForm" id="tarjetaSeleccionadaForm" value="' . TpvVirtualAPI::SI_RECORDAR . '">
                                        </td>
                                    </tr>
                                </table>
                            </div>
                        </div>
                    </div>';

        return $template1;
    }

    private function ObtenerPlantilla2($tarjetasDisponibles)
    {
        global $customer_id;
        $tarjetasSel = '';

        foreach ($tarjetasDisponibles as $tarjeta) {

            $jsonData = '{"customer":"' . $customer_id . '","tarjetaSeleccionada":"' . $tarjeta['id_tarjeta'] . '"}';
            $tarjetasSel .= ' <tr>
                    <td style="padding-bottom: 0px;">                        
                        <a name="BorrarTarjeta" href="javascript:void(0)" data-tarjeta-seleccionada=' . $jsonData . ' title="Borrar tarjeta">
                            <img src="images/modules/payment/tpvbbva/error.gif" style=" float:left;padding-right: 10px;">
                        </a>
                        <img src="images/modules/payment/tpvbbva/tarjeta.png" style="float:left;padding-right: 10px;">Efectuar pago con la tarjeta <strong>' . $tarjeta['id_tarjeta'] . '</strong>
                    </td>
                    <td style="padding-bottom: 0px;text-align: center"><input type="radio" name="tarjetaSeleccionadaForm" id="tarjetaSeleccionadaForm" value="' . $tarjeta['id_tarjeta'] . '"></td>
                </tr>';
        }


        $masTarjetas = '';

        if (count($tarjetasDisponibles) < 3) {
            $masTarjetas = '<tr>
                                <td style = "padding-bottom: 0px;" > Recordar la tarjeta para futuros pagos </td >
                                <td style = "padding-bottom: 0px;text-align: center" >
                                <input type = "radio" name = "tarjetaSeleccionadaForm" id = "tarjetaSeleccionadaForm" value = "' . TpvVirtualAPI::SI_RECORDAR . ' " >
                                </td >
                             </tr >';
        }


        $plantilla2 = '<div id="ncp_tpv_virtual" style="border: 1px solid #d6d4d4;    border-radius: 10px;padding: 15px;width: 600px;">
                        <div style="display:inline-block;width: 100%;">
                            <div id="encabezado" style="float: left;width: 100%; font-weight: bold;padding-bottom: 20px;padding-top:20px ">
                                 <img src="images/modules/payment/tpvbbva/logo.png" style="border: 0px; vertical-align: text-bottom; margin-right: 10px; float:left;"/><br><br>
                                Pago con tarjeta de credito a traves del TPV Virtual.
                            </div>
                            <div id="opciones">
                                <table style="width: 100%;">' . $tarjetasSel . '
                                    <tr>
                                        <td colspan="2" style="padding: 0px 0px 0px 0px;">
                                            <hr>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td style="padding-bottom: 0px;"><strong>NO</strong> recordar la tarjeta para futuros pagos</td>
                                        <td style="padding-bottom: 0px;text-align: center">
                                            <input type="radio" name="tarjetaSeleccionadaForm" id="tarjetaSeleccionadaForm" value="' . TpvVirtualAPI::NO_RECORDAR . '" checked="checked">
                                        </td>
                                    </tr>
                                   ' . $masTarjetas . '
                                </table>
                            </div>
                        </div>
                    </div>';


        $plantilla2 .= '<script type="text/javascript">
                             function BorraTarjeta(element, idCustomer, idTarjeta) {                            
                                        if (confirm("¿Desea realmente eliminar la tarjeta seleccionada?")) {
                                            $.ajax({
                                                type: "GET",
                                                url: "' . tep_href_link('ext/modules/payment/tpvbbva/tpv_virtual_borrarTarjeta.php', '', 'SSL') . '",
                                                dataType: \'jsonp\',
                                                jsonp: \'callback\',
                                                crossDomain: true,
                                                data: {customer: idCustomer, tarjetaSeleccionada: idTarjeta},                                                
                                                success: function (data) {
                                                      if (!data.BORRADO){
                                                            alert("Se ha producido un problema borrando la tarjeta del sistema.");
                                                            console.log(data.MSG);                                                             
                                                      }
                                                       else
                                                            $(element).parent().parent().remove();
                                                },
                                                error: function () {
                                                    alert("Se ha producido un error borrando la tarjeta. Por favor intentelo más tarde.");                                                    
                                                }
                                            });
                                        }
                                        return false;
                                    }
                                    
                                     $(document).ready(function () {
                                        $(\'[name=BorrarTarjeta]\').click(function () {
                                            var idCustomer = $(this).data("tarjeta-seleccionada").customer;
                                            var idTarjeta = $(this).data("tarjeta-seleccionada").tarjetaSeleccionada;                                            
                                            BorraTarjeta(this, idCustomer, idTarjeta);
                                        });
                                    });
                        </script>';


        return $plantilla2;
    }

    /*
     * Generador del selector del módulo de pago.
     */
    function selection()
    {
        global $customer_id;
        $_SESSION["NcpTpvVirtual/BBVA/Customer-[" . $customer_id . "]"] = "";

        $tarjetasDisponibles = Tarjetas::obtenerTarjetasCliente($customer_id);
        //if (count($tarjetasDisponibles) == 0)
        //    $template = $this->ObtenerPlantilla1();
        //else
            $template = $this->ObtenerPlantilla2($tarjetasDisponibles);


        if (MODULE_PAYMENT_TPV_VIRTUAL_PAGO_REFERENCIA == "SI") {

            $selection = array(
                'id' => $this->code,
                'module' => $this->title,
                'fields' => array(
                    array('title' => $template, 'field' => ''))
            );


        } else {
            $selection = array('id' => $this->code, 'module' => $this->title);
        }

        return $selection;
    }

    function pre_confirmation_check()
    {

        global $HTTP_POST_VARS, $customer_id;
        $tarjetaSeleccionada = $HTTP_POST_VARS['tarjetaSeleccionadaForm'];

        if (isset($tarjetaSeleccionada) && strlen($tarjetaSeleccionada) > 0) {
            $_SESSION["NcpTpvVirtual/BBVA/Customer-[" . $customer_id . "]"] = $tarjetaSeleccionada;
        } else {
            $paymentErrorReturn = "Error a la hora de seleccionar la tarjeta";
            tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $paymentErrorReturn, 'SSL', true, false));
        }
    }

    function confirmation()
    {
        return false;
    }

    function process_button()
    {
        global $order, $currency, $language, $customer_id;

        $ds_merchant_code = constant('MODULE_PAYMENT_TPV_VIRTUAL_CODIGO_FUC');
        $ds_Merchant_MerchantName = constant('MODULE_PAYMENT_TPV_VIRTUAL_NOMBRE_COMERCIO');
        $ds_merchant_order = "1" . time();
        $ds_merchant_data = tep_session_id();

        //Importe
        $total = $order->info['total'];
        $ds_merchant_amount = round($total * $order->info['currency_value'], 2);
        $ds_merchant_amount = number_format($ds_merchant_amount, 2, '.', '');
        $ds_merchant_amount = preg_replace('/\./', '', $ds_merchant_amount);

        $ds_merchant_currency = TpvVirtualAPI::obtenerCodMoneadaPorNombre(constant('MODULE_PAYMENT_TPV_VIRTUAL_MERCHANT_CURRENCY1'));
        $ds_merchant_terminal = constant('MODULE_PAYMENT_TPV_VIRTUAL_TERMINAL1');
        $claveEncriptacion = constant('MODULE_PAYMENT_TPV_VIRTUAL_CLAVE1');

        //Obtenemos el tipo de transaccion que vamos a emplear
        $transaccionConfigurada = constant('MODULE_PAYMENT_TPV_VIRTUAL_TIPO_TRANSACCION');
        $arrayTransacciones = TpvVirtualAPI::tiposTransaccion('es');
        $ds_merchant_transactiontype = $arrayTransacciones[$transaccionConfigurada];

        //Obtenemos el idioma configurado y obtenemos el valor correcto en para el TPV Virtual.
        $idiomaConfigurado = constant('MODULE_PAYMENT_TPV_VIRTUAL_IDIOMA');
        $arrayIdiomas = TpvVirtualAPI::idiomas('es');

        if ($idiomaConfigurado == '-- Auto --') {
            $ds_merchant_consumerlanguage = TpvVirtualAPI::isoToTPV($this->getCurrentLanguage());
        } else {
            $ds_merchant_consumerlanguage = $arrayIdiomas[$idiomaConfigurado];
        }

        $ds_merchant_merchanturl = "";
        $ds_merchant_urlko = tep_href_link('ext/modules/payment/tpvbbva/tpv_virtual_ko.php', '', 'SSL');
        $ds_merchant_urlok = tep_href_link('ext/modules/payment/tpvbbva/tpv_virtual_callback.php', '', 'SSL');

        $redsysAPI = new RedsysAPI;
        $redsysAPI->setParameter("DS_MERCHANT_AMOUNT", $ds_merchant_amount);
        $redsysAPI->setParameter("DS_MERCHANT_ORDER", strval($ds_merchant_order));
        $redsysAPI->setParameter("DS_MERCHANT_MERCHANTCODE", $ds_merchant_code);
        $redsysAPI->setParameter("DS_MERCHANT_CURRENCY", $ds_merchant_currency);
        $redsysAPI->setParameter("DS_MERCHANT_TRANSACTIONTYPE", $ds_merchant_transactiontype);
        $redsysAPI->setParameter("DS_MERCHANT_TERMINAL", $ds_merchant_terminal);
        $redsysAPI->setParameter("DS_MERCHANT_MERCHANTURL", $ds_merchant_merchanturl);
        $redsysAPI->setParameter("DS_MERCHANT_URLOK", $ds_merchant_urlok);
        $redsysAPI->setParameter("DS_MERCHANT_URLKO", $ds_merchant_urlko);
        $redsysAPI->setParameter("DS_MERCHANT_MERCHANTNAME", $ds_Merchant_MerchantName);
        $redsysAPI->setParameter("DS_MERCHANT_CONSUMERLANGUAGE", $ds_merchant_consumerlanguage);


        $ds_merchant_identifier = "";
        $ds_merchant_data = "";

        if (MODULE_PAYMENT_TPV_VIRTUAL_PAGO_REFERENCIA == "SI") {
            $tarjetaSeleccionada = $_SESSION["NcpTpvVirtual/BBVA/Customer-[" . $customer_id . "]"];

            //Si no es ninguno de estos valores obtenemos la referencia de la tarjeta.
            if ($tarjetaSeleccionada != TpvVirtualAPI::NO_RECORDAR && $tarjetaSeleccionada != TpvVirtualAPI::SI_RECORDAR) {
                $tarjetaCliente = Tarjetas::obtenerTarjetaCliente($customer_id, $tarjetaSeleccionada);

                //Compruebo que la tarjeta exista y si existe que no esté caducada. En caso de estar caducada solicitaremos una nueva referencia.
                if (($tarjetaCliente == null || strlen($tarjetaCliente['referencia_tarjeta']) == 0) || (strlen($tarjetaCliente['referencia_tarjeta']) > 0 && date("ym") > $tarjetaCliente['caducidad'])) {
                    $ds_merchant_identifier = TpvVirtualAPI::NUEVA_REFERENCIA;
                } else {
                    $ds_merchant_identifier = $tarjetaCliente['referencia_tarjeta'];
                }

            } elseif ($tarjetaSeleccionada == TpvVirtualAPI::SI_RECORDAR) {
                $ds_merchant_identifier = TpvVirtualAPI::NUEVA_REFERENCIA;
            }

            $redsysAPI->setParameter("DS_MERCHANT_IDENTIFIER", $ds_merchant_identifier);
            $ds_merchant_data = '{"customer":"' . $customer_id . '","tarjetaSeleccionada":"' . $tarjetaSeleccionada . '"}';
            $redsysAPI->setParameter("DS_MERCHANT_MERCHANTDATA", $ds_merchant_data);
            $ds_merchant_data = htmlspecialchars($ds_merchant_data, ENT_QUOTES);
        }

        $DsMerchantParameters = $redsysAPI->createMerchantParameters();
        $DsSignature = $redsysAPI->createMerchantSignature($claveEncriptacion);

        return TpvVirtualAPI::obtenerFormularioTPVSinForm($ds_merchant_amount, $ds_merchant_currency, $ds_merchant_order, $ds_merchant_code, $ds_merchant_terminal, $ds_merchant_transactiontype, TITLE, $ds_Merchant_MerchantName, $ds_merchant_merchanturl, 'CompraTienda', $ds_merchant_urlok, $ds_merchant_urlko, $ds_merchant_consumerlanguage, $ds_merchant_data, $DsMerchantParameters, $DsSignature, $ds_merchant_identifier);

    }

    function check()
    {
        if (!isset($this->_check)) {
            $check_query = tep_db_query("select * from " . TABLE_CONFIGURATION . " where configuration_key like 'MODULE_PAYMENT_TPV_VIRTUAL_%'");
            $this->_check = ((tep_db_num_rows($check_query) > 0) ? true : false);
        }
        return $this->_check;
    }

    function keys()
    {
        $claves = array();
        array_push($claves, 'MODULE_PAYMENT_TPV_VIRTUAL_ESTADO');
        array_push($claves, "MODULE_PAYMENT_TPV_VIRTUAL_URL");
        array_push($claves, "MODULE_PAYMENT_TPV_VIRTUAL_URL_PRUEBAS");
        array_push($claves, "MODULE_PAYMENT_TPV_VIRTUAL_ENTORNO");
        array_push($claves, "MODULE_PAYMENT_TPV_VIRTUAL_TIPO_TRANSACCION");
        array_push($claves, "MODULE_PAYMENT_TPV_VIRTUAL_PAGO_REFERENCIA");
        array_push($claves, "MODULE_PAYMENT_TPV_VIRTUAL_NOMBRE_COMERCIO");
        array_push($claves, "MODULE_PAYMENT_TPV_VIRTUAL_CODIGO_FUC");
        array_push($claves, "MODULE_PAYMENT_TPV_VIRTUAL_IDIOMA");
        array_push($claves, "MODULE_PAYMENT_TPV_VIRTUAL_TERMINAL1");
        array_push($claves, "MODULE_PAYMENT_TPV_VIRTUAL_CLAVE1");
        array_push($claves, "MODULE_PAYMENT_TPV_VIRTUAL_MERCHANT_CURRENCY1");
        return $claves;
    }

    function before_process()
    {
        return false;
    }

    function after_process()
    {
        return false;
    }

    function output_error()
    {
        return false;
    }

    function getCurrentLanguage()
    {
        global $languages_id;
        $languages_query = tep_db_query("select languages_id, name, code, image, directory from " . TABLE_LANGUAGES . " order by sort_order");

        while ($languages = tep_db_fetch_array($languages_query)) {
            $languages_array[] = array('id' => $languages['languages_id'],
                'name' => $languages['name'],
                'code' => $languages['code'],
                'image' => $languages['image'],
                'directory' => $languages['directory']);
        }

        $languages_array;

        $languageISO = $languages_array[$languages_id]['code'];
        return $languageISO;
    }

    function getCurrenciesInstalled()
    {
        $currencies = array();
        $currency_query_raw = "select currencies_id, title, code, symbol_left, symbol_right, decimal_point, thousands_point, decimal_places, last_updated, value from " . TABLE_CURRENCIES . " order by title";
        $currency_query = tep_db_query($currency_query_raw);

        while ($currency = tep_db_fetch_array($currency_query)) {
            $cInfo = new objectInfo($currency);
            array_push($currencies, $cInfo);
        }

        return $currencies;
    }

    private function createOrderStatus()
    {

        //Consultamos todos los idiomas instalados.
        //Si el idioma es Español o Catalán se pondran sus respectivos idiomas, en caso contrario se instalará en inglés.
        $idiomasInstalados_query = tep_db_query("SELECT languages_id, name, code FROM languages");

        //Obtengo el último identificador para ir insertando a partir de el.
        $last_id_query = tep_db_query("SELECT MAX(orders_status_id) ultimo_id FROM orders_status");
        $last_id = tep_db_fetch_array($last_id_query);

        //Incrementamos en 1 al identificador.
        $last_id = $last_id['ultimo_id'];
        $last_id++;

        $identificadores = array();

        while ($idiomaInstalado = tep_db_fetch_array($idiomasInstalados_query)) {
            $idiomaElegido = "en"; //Ingles

            if ($idiomaInstalado['code'] === 'es')
                $idiomaElegido = "es"; //Español
            else if (strpos($idiomaInstalado['code'], 'cat') !== false)
                $idiomaElegido = "ca"; //Catalan

            $idiomaEstado = TpvVirtualAPI::obtenerIdiomaEstado($idiomaElegido);

            if (count($identificadores) === 0) {
                $cont = 0;
                foreach ($idiomaEstado as $estado) {
                    //Insertamos el nuevo estado
                    tep_db_query("INSERT INTO orders_status SET orders_status_id =" . $last_id . ", language_id = '" . (int)$idiomaInstalado['languages_id'] . "', orders_status_name = '" . $estado . "'");
                    //Insertamos el estado que hay en Opencart
                    tep_db_query("INSERT INTO NCP_TPV_VIRTUAL_ESTADO_OPERACION SET id_estado = " . (int)$cont . ", id_estado_ecommerce = " . $last_id);
                    //Guardamos los identificadores.
                    array_push($identificadores, $last_id);
                    $cont++;
                    $last_id++;
                }
            } else {
                $cont = 0;
                foreach ($idiomaEstado as $estado) {
                    tep_db_query("INSERT INTO orders_status SET orders_status_id = '" . (int)$identificadores[$cont] . "', language_id = '" . (int)$idiomaInstalado['languages_id'] . "', orders_status_name = '" . $estado . "'");
                    $cont++;
                }
            }
        }
    }

//Se ejecuta durante la instalacion del modulo
    function install()
    {

        tep_db_query("CREATE TABLE IF NOT EXISTS `NCP_TPV_VIRTUAL_OPERACIONES` (
                        `id_order` int(10) NOT NULL,
                        `reference` varchar(9) NOT NULL,
                        `merchant_order` varchar(12) NOT NULL,
                        `merchant_code` varchar(9) NOT NULL,
                        `importe_cobrado` decimal(17,2) NOT NULL,
                        `importe_devuelto` decimal(17,2) NOT NULL,
                        `id_terminal` int(3) DEFAULT NULL,
                        `moneda` varchar(3) DEFAULT NULL,
                        `clave_encriptacion` text NOT NULL,
                        `tipo_pago` varchar(2) DEFAULT NULL,
                        `id_estado` int(1) NOT NULL,
                        PRIMARY KEY (`id_order`)
                        );
            ");

        tep_db_query("CREATE TABLE IF NOT EXISTS `NCP_TPV_VIRTUAL_ESTADO_OPERACION` (
                        `id_estado` int(11) NOT NULL,
                        `id_estado_ecommerce` int(11) DEFAULT NULL,
                        PRIMARY KEY (`id_estado`)
                        ) ;
                    ");

        tep_db_query("CREATE TABLE IF NOT EXISTS NCP_TPV_VIRTUAL_PAGO_REFERENCIA (
                        id_customer int(10) NOT NULL,
                        id_tarjeta varchar(50) NOT NULL,
                        referencia_tarjeta varchar(40) DEFAULT NULL,
                        caducidad varchar(4) DEFAULT NULL,
                        fecha_alta datetime DEFAULT NULL,
                        fecha_actualizacion datetime DEFAULT NULL,
                        PRIMARY KEY(id_customer,id_tarjeta));"
        );

        $this->createOrderStatus();


        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Activar módulo BBVA', 'MODULE_PAYMENT_TPV_VIRTUAL_ESTADO', 'True', 'Habilitado', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('URL Real', 'MODULE_PAYMENT_TPV_VIRTUAL_URL', '" . TpvVirtualAPI::urlReal() . "', '', '6', '3', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('URL Test', 'MODULE_PAYMENT_TPV_VIRTUAL_URL_PRUEBAS', '" . TpvVirtualAPI::urlTest() . "', '', '6', '2', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Entorno activo', 'MODULE_PAYMENT_TPV_VIRTUAL_ENTORNO', 'Test', 'Indique el entorno en el que va a operar', '6', '4', 'tep_cfg_select_option(array(\'Real\', \'Test\'), ', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Tipo de transaccion', 'MODULE_PAYMENT_TPV_VIRTUAL_TIPO_TRANSACCION', 'Pago estándar o Autorización', 'Seleccione el comportamiento del TPV Virtual', '6', '5', 'tep_cfg_select_option(array_keys(TpvVirtualAPI::tiposTransaccion(\'es\')),', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Habilitar pago por referencia', 'MODULE_PAYMENT_TPV_VIRTUAL_PAGO_REFERENCIA', 'NO','Habilita/Deshabilita el pago por referencia en el TPV Virtual', '6', '1', 'tep_cfg_select_option(array(SI, NO), ', now())");

        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Nombre de comercio', 'MODULE_PAYMENT_TPV_VIRTUAL_NOMBRE_COMERCIO', '', '', '6', '6', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Código FUC', 'MODULE_PAYMENT_TPV_VIRTUAL_CODIGO_FUC', '', 'Código de comercio proporcionado por la entidad bancaria', '6', '7', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Idioma', 'MODULE_PAYMENT_TPV_VIRTUAL_IDIOMA', 'Castellano', 'Seleccione el idioma del TPV Virtual', '6', '8', 'tep_cfg_select_option(array_keys(TpvVirtualAPI::idiomas(\'es\')),', now())");

        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Terminal', 'MODULE_PAYMENT_TPV_VIRTUAL_TERMINAL1', '', '', '6', '9', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Clave de Encriptación', 'MODULE_PAYMENT_TPV_VIRTUAL_CLAVE1', '', '', '6', '10', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Código moneda', 'MODULE_PAYMENT_TPV_VIRTUAL_MERCHANT_CURRENCY1', 'Euro', 'Seleccione la moneda del TPV Virtual', '6', '11', 'tep_cfg_select_option(array_keys(TpvVirtualAPI::monedas(\'es\')),', now())");


    }

    //Se ejecutará en la desinstalación del modulo.
    function remove()
    {
        //Se borran todas las variables de configuración del módulo
        tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");

        //Borramos las tablas que hacen funcionar al modulo.
        tep_db_query("DROP TABLE IF EXISTS `NCP_TPV_VIRTUAL_OPERACIONES`;");
        tep_db_query("DROP TABLE IF EXISTS `NCP_TPV_VIRTUAL_ESTADO_OPERACION`;");
        tep_db_query("DROP TABLE IF EXISTS `NCP_TPV_VIRTUAL_PAGO_REFERENCIA`;");
    }
}

?>