<?php

class Tarjetas
{
    static function obtenerTarjetasCliente($idCustomer)
    {
        $query = tep_db_query("SELECT id_customer, id_tarjeta, referencia_tarjeta, caducidad FROM NCP_TPV_VIRTUAL_PAGO_REFERENCIA WHERE id_customer=" . trim($idCustomer));
        $tarjetas = array();

        while ($tarjeta = tep_db_fetch_array($query)) {
            if (strlen($tarjeta['id_tarjeta']) > 0) {
                $tarjetas[] = $tarjeta;
            }
        }

        if (count($tarjetas) > 0)
            return $tarjetas;
        else
            return null;
    }

    /**
     * Obtenemos la tarjeta de un cliente almacenada en nuestro registro.
     * @param $idCustomer
     * @param $idTarjeta
     * @return null
     */
    static function obtenerTarjetaCliente($idCustomer, $idTarjeta)
    {
        $query = "SELECT id_customer, id_tarjeta, referencia_tarjeta, caducidad FROM NCP_TPV_VIRTUAL_PAGO_REFERENCIA WHERE id_customer=" . trim($idCustomer) . " AND id_tarjeta='" . trim($idTarjeta) . "'";
        $query = tep_db_query($query);
        $tarjeta = tep_db_fetch_array($query);

        if ($tarjeta != null) {
            return $tarjeta;
        } else
            return null;
    }

    static function insertaTarjetaCliente($idCustomer, $idTarjeta, $referenciaTarjeta, $referenciaCaducidad)
    {
        $query = 'INSERT INTO NCP_TPV_VIRTUAL_PAGO_REFERENCIA VALUES(' . (int)$idCustomer . ',"' . trim($idTarjeta) . '","' . trim($referenciaTarjeta) . '","' . trim($referenciaCaducidad) . '","' . date("Y-m-d H:i:s") . '",null)';
        try {
            tep_db_query($query);
        } catch (Exception $e) {
            echo($e->getMessage());
        }
    }

    static function actualizaTarjetaCliente($idcustomer, $idTarjeta, $referenciaTarjeta, $referenciaCaducidad)
    {
        $query = 'UPDATE NCP_TPV_VIRTUAL_PAGO_REFERENCIA SET referencia_tarjeta="' . trim($referenciaTarjeta) . '", caducidad= "' . trim($referenciaCaducidad) . '", fecha_actualizacion="' . date("Y-m-d H:i:s") . '"  WHERE id_customer = ' . trim($idcustomer) . ' AND id_tarjeta="' . trim($idTarjeta) . '"';

        try {
            tep_db_query($query);
        } catch (Exception $e) {
            echo($e->getMessage());
        }
    }

    static function insertaOActualizaTarjetaCliente($idcustomer, $idTarjeta, $referenciaTarjeta, $referenciaCaducidad)
    {

        $tarjetaCliente = Tarjetas::obtenerTarjetaCliente($idcustomer, $idTarjeta);

        if ($tarjetaCliente == null) {
            Tarjetas::insertaTarjetaCliente($idcustomer, $idTarjeta, $referenciaTarjeta, $referenciaCaducidad);
        } else {
            Tarjetas::actualizaTarjetaCliente($idcustomer, $idTarjeta, $referenciaTarjeta, $referenciaCaducidad);
        }
    }

    static function borraTarjetaCliente($idcustomer, $idTarjeta)
    {
        $query = 'DELETE FROM NCP_TPV_VIRTUAL_PAGO_REFERENCIA  WHERE id_customer = ' . trim($idcustomer) . ' AND id_tarjeta="' . trim($idTarjeta) . '"';

        try {
            tep_db_query($query);
        } catch (Exception $e) {
            echo($e->getMessage());
        }
    }

    static function borraTarjetasCaducadasCliente($idcustomer)
    {
        $query = 'DELETE FROM NCP_TPV_VIRTUAL_PAGO_REFERENCIA  WHERE id_customer = ' . trim($idcustomer) . ' AND CONVERT(caducidad,UNSIGNED INTEGER)<' . date("ym");

        try {
            tep_db_query($query);
        } catch (Exception $e) {
            echo($e->getMessage());
        }
    }

}