<?php
chdir('../../../../');
require('includes/application_top.php');
include('includes/' . $language . '/tpv_virtual_transactions.php');
require('includes/template_top.php');

if (!class_exists('RedsysAPI')) require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . 'TpvVirtual' . DIRECTORY_SEPARATOR . 'RedsysAPI.php');

function obtenerDatosOperacionTpvVirtual($ds_order)
{

    $tpvVirtuaOperaciones = array();

    if ($ds_order > 0) {

        $consulta = "SELECT so.id_order,
                            so.merchant_order, 
                            so.merchant_code, 
                            so.importe_cobrado, 
                            so.importe_devuelto, 
                            so.id_terminal, 
                            so.moneda, 
                            so.clave_encriptacion, 
                            so.tipo_pago, 
                            so.id_estado, 
                            seo.id_estado_ecommerce
            FROM NCP_TPV_VIRTUAL_OPERACIONES so
            JOIN NCP_TPV_VIRTUAL_ESTADO_OPERACION seo ON seo.id_estado = so.id_estado
            WHERE so.merchant_order = " . $ds_order . " ORDER BY id_order  ";

        $query = tep_db_query($consulta);
        $tpvVirtuaOperaciones = tep_db_fetch_array($query);
    }

    return $tpvVirtuaOperaciones;
}

$ds_amount = "";
$ds_currency = "";
$ds_order = "";
$ds_merchantcode = "";
$ds_terminal = "";
$ds_response = "";
$ds_transactiontype = "";
$ds_date = "";
$ds_hour = "";
$ds_AuthorisationCode = "";
$ds_ErrorCode = "";
$ds_SignatureVersion = "";
$ds_Signature = "";
$ds_MerchantParameters = "";

$order_id = '';

if (isset($_GET['oID']))
    $order_id = $_GET['oID'];
else {

    if (isset($_POST) && count($_POST) > 0) {

        if (isset($_POST['Ds_SignatureVersion']))
            $ds_SignatureVersion = $_POST["Ds_SignatureVersion"];

        if (isset($_POST['Ds_MerchantParameters']))
            $ds_MerchantParameters = $_POST["Ds_MerchantParameters"];

        if (isset($_POST['Ds_Signature']))
            $ds_Signature = $_POST["Ds_Signature"];
    } else if (isset($_GET) && count($_GET) > 0) {

        if (isset($_GET['Ds_SignatureVersion']))
            $ds_SignatureVersion = $_GET["Ds_SignatureVersion"];

        if (isset($_GET['Ds_MerchantParameters']))
            $ds_MerchantParameters = $_GET["Ds_MerchantParameters"];

        if (isset($_GET['Ds_Signature']))
            $ds_Signature = $_GET["Ds_Signature"];

    }

    $miObj = new RedsysAPI;
    $decodec = $miObj->decodeMerchantParameters($ds_MerchantParameters);
    $miObj->stringToArray($decodec);
    $ds_amount = $miObj->getParameter("Ds_Amount");
    $ds_order = $miObj->getParameter("Ds_Order");
    $ds_merchantcode = $miObj->getParameter("Ds_MerchantCode");
    $ds_currency = $miObj->getParameter("Ds_Currency");
    $ds_transactiontype = $miObj->getParameter("Ds_TransactionType");
    $ds_terminal = $miObj->getParameter("Ds_Terminal");
    $ds_response = $miObj->getParameter('Ds_Response');
    $ds_AuthorisationCode = $miObj->getParameter('Ds_AuthorisationCode');
    $ds_date = $miObj->getParameter('Ds_Date');
    $ds_hour = $miObj->getParameter('Ds_Hour');
    $datosOperacion = obtenerDatosOperacionTpvVirtual($ds_order);
    $order_id = $datosOperacion['id_order'];
}
?>

<table border="0" width="100%" cellspacing="0" cellpadding="2">
    <tr>
        <td width="100%">
            <table border="0" width="100%" cellspacing="0" cellpadding="0">
                <tr>
                    <td class="pageHeading"><img src="../../../../../images/modules/payment/tpvbbva/logo.png"
                                                 alt="BBVA">&nbsp;<?php echo HEADING_TITLE; ?></td>
                    <td class="pageHeading"
                        align="right"><?php echo tep_draw_separator('pixel_trans.gif', 1, HEADING_IMAGE_HEIGHT); ?></td>
                    <td class="smallText" align="right">
                        <?= tep_draw_button(IMAGE_BACK, 'triangle-1-w', tep_href_link(TPV_VIRTUAL_FILENAME_ORDERS, 'oID=' . $order_id . "&action=edit")) ?>

                    </td>
                </tr>
            </table>
        </td>
    </tr>
    <tr>
        <td>
            <table width="100%" border="0" cellspacing="0" cellpadding="2">
                <tr>
                    <td colspan="3"><?php echo tep_draw_separator(); ?></td>
                </tr>
                <tr>
                    <td valign="top">
                        <?= '<center><span style="color:red">' . BS_ERROR_CALLBACK . '</span></center>' ?>
                    </td>
                </tr>
                <tr>
                    <td>
                        <?php
                        /*if (isset($ds_amount))
                            echo "ds_amount: " . $ds_amount . "<br>";

                        if (isset($ds_order))
                            echo "ds_order: " . $ds_order . "<br>";

                        if (isset($ds_merchantcode))
                            echo "ds_merchantcode: " . $ds_merchantcode . "<br>";

                        if (isset($ds_currency))
                            echo "ds_currency: " . $ds_currency . "<br>";

                        if (isset($ds_transactiontype))
                            echo "ds_transactiontype: " . $ds_transactiontype . "<br>";

                        if (isset($ds_terminal))
                            echo "ds_terminal: " . $ds_terminal . "<br>";

                        if (isset($ds_response))
                            echo "ds_response: " . $ds_response . "<br>";

                        if (isset($ds_transactiontype))
                            echo "ds_transactiontype: " . $ds_transactiontype . "<br>";

                        if (isset($ds_AuthorisationCode))
                            echo "ds_AuthorisationCode: " . $ds_AuthorisationCode . "<br>";*/

                        ?>
                    </td>
                </tr>
            </table>
        </td>
    </tr>
</table>
<?php
require(DIR_WS_INCLUDES . 'template_bottom.php');
require(DIR_WS_INCLUDES . 'application_bottom.php');
?>
