﻿<?php

// look in your $PATH_LOCALE/locale directory for available locales..
// on RedHat6.0 I used 'en_US'
// on FreeBSD 4.0 I use 'en_US.ISO_8859-1'
// this may not work under win32 environments..
setlocale(LC_ALL, array('en_US.UTF-8', 'en_US.UTF8', 'enu_usa'));
define('DATE_FORMAT_SHORT', '%m/%d/%Y');  // this is used for strftime()
define('DATE_FORMAT_LONG', '%A %d %B, %Y'); // this is used for strftime()
define('DATE_FORMAT', 'm/d/Y'); // this is used for date()
define('PHP_DATE_TIME_FORMAT', 'm/d/Y H:i:s'); // this is used for date()
define('DATE_TIME_FORMAT', DATE_FORMAT_SHORT . ' %H:%M:%S');
define('JQUERY_DATEPICKER_I18N_CODE', ''); // leave empty for en_US; see http://jqueryui.com/demos/datepicker/#localization
define('JQUERY_DATEPICKER_FORMAT', 'mm/dd/yy'); // see http://docs.jquery.com/UI/Datepicker/formatDate

////
// Return date in raw format
// $date should be in format mm/dd/yyyy
// raw date is in format YYYYMMDD, or DDMMYYYY
function tep_date_raw($date, $reverse = false) {
  if ($reverse) {
    return substr($date, 3, 2) . substr($date, 0, 2) . substr($date, 6, 4);
  } else {
    return substr($date, 6, 4) . substr($date, 0, 2) . substr($date, 3, 2);
  }
}

// Global entries for the <html> tag
define('HTML_PARAMS','dir="ltr" lang="es"');

// charset for web pages and emails
define('CHARSET', 'utf-8');

// page title
define('TITLE', 'osCommerce Online Merchant Administration Tool');

// header text in includes/header.php
define('HEADER_TITLE_TOP', 'Administración');
define('HEADER_TITLE_SUPPORT_SITE', 'Soporte');
define('HEADER_TITLE_ONLINE_CATALOG', 'Catálogo');
define('HEADER_TITLE_ADMINISTRATION', 'Administración');

// text for gender
define('MALE', 'Hombre');
define('FEMALE', 'Mujer');

// text for date of birth example
define('DOB_FORMAT_STRING', 'mm/dd/yyyy');

// configuration box text in includes/boxes/configuration.php
define('BOX_HEADING_CONFIGURATION', 'Configuración');
define('BOX_CONFIGURATION_MYSTORE', 'Mi Tienda');
define('BOX_CONFIGURATION_LOGGING', 'Inicio de Sesión');
define('BOX_CONFIGURATION_CACHE', 'Cache');
define('BOX_CONFIGURATION_ADMINISTRATORS', 'Administradores');
define('BOX_CONFIGURATION_STORE_LOGO', 'Logotipo de la Tienda');

// modules box text in includes/boxes/modules.php
define('BOX_HEADING_MODULES', 'Módulos');

// categories box text in includes/boxes/catalog.php
define('BOX_HEADING_CATALOG', 'Catálogos');
define('BOX_CATALOG_CATEGORIES_PRODUCTS', 'Categorías/Productos');
define('BOX_CATALOG_CATEGORIES_PRODUCTS_ATTRIBUTES', 'Atributos de Productos');
define('BOX_CATALOG_MANUFACTURERS', 'Fabricantes');
define('BOX_CATALOG_REVIEWS', 'Comentarios');
define('BOX_CATALOG_SPECIALS', 'Especiales');
define('BOX_CATALOG_PRODUCTS_EXPECTED', 'Productos Esperados');

// customers box text in includes/boxes/customers.php
define('BOX_HEADING_CUSTOMERS', 'Clientes');
define('BOX_CUSTOMERS_CUSTOMERS', 'Clientes');
define('BOX_CUSTOMERS_ORDERS', 'Pedidos');
define('TPV_VIRTUAL_BOX_CUSTOMERS_ORDERS', 'Pedidos BBVA');

// orders box text in includes/boxes/orders.php
define('BOX_HEADING_ORDERS', 'Pedidos');
define('BOX_ORDERS_ORDERS', 'Pedidos');

// taxes box text in includes/boxes/taxes.php
define('BOX_HEADING_LOCATION_AND_TAXES', 'Localizaciones / Tasas');
define('BOX_TAXES_COUNTRIES', 'Países');
define('BOX_TAXES_ZONES', 'Zonas');
define('BOX_TAXES_GEO_ZONES', 'Tasas de Zonas');
define('BOX_TAXES_TAX_CLASSES', 'Clases de Tasas');
define('BOX_TAXES_TAX_RATES', 'Valores de Tasas');

// reports box text in includes/boxes/reports.php
define('BOX_HEADING_REPORTS', 'Informes');
define('BOX_REPORTS_PRODUCTS_VIEWED', 'Productos Vistos');
define('BOX_REPORTS_PRODUCTS_PURCHASED', 'Productos Comprados');
define('BOX_REPORTS_ORDERS_TOTAL', 'Pedidos Totales de Clientes');

// tools text in includes/boxes/tools.php
define('BOX_HEADING_TOOLS', 'Herramientas');
define('BOX_TOOLS_ACTION_RECORDER', 'Acciones Grabadas');
define('BOX_TOOLS_BACKUP', 'Copia de Seguridad de BD');
define('BOX_TOOLS_BANNER_MANAGER', 'Gestor de Banners');
define('BOX_TOOLS_CACHE', 'Control de Cache');
define('BOX_TOOLS_DEFINE_LANGUAGE', 'Definir Idiomas');
define('BOX_TOOLS_MAIL', 'Enviar Email');
define('BOX_TOOLS_NEWSLETTER_MANAGER', 'Control de Boletín de Noticias');
define('BOX_TOOLS_SEC_DIR_PERMISSIONS', 'Permisos de Seguridad de los Directorios');
define('BOX_TOOLS_SERVER_INFO', 'Información del Servidor');
define('BOX_TOOLS_VERSION_CHECK', 'Comprobador de Versión');
define('BOX_TOOLS_WHOS_ONLINE', '¿Quién está conectado?');

// localizaion box text in includes/boxes/localization.php
define('BOX_HEADING_LOCALIZATION', 'Localización');
define('BOX_LOCALIZATION_CURRENCIES', 'Divisas');
define('BOX_LOCALIZATION_LANGUAGES', 'Idiomas');
define('BOX_LOCALIZATION_ORDERS_STATUS', 'Estado de Pedidos');

// javascript messages
define('JS_ERROR', '¡Han ocurrido errores durante el proceso de su formulario!\nPor favor, realice las siguientes correciones:\n\n');

define('JS_OPTIONS_VALUE_PRICE', '* El nuevo atributo del producto necesita un valor para el precio\n');
define('JS_OPTIONS_VALUE_PRICE_PREFIX', '* El nuevo atributo del producto necesita un prefijo del precio\n');

define('JS_PRODUCTS_NAME', '* El nuevo producto necesita un nombre\n');
define('JS_PRODUCTS_DESCRIPTION', '* El nuevo producto necesita una descripción\n');
define('JS_PRODUCTS_PRICE', '* El nuevo producto necesita un valor para el precio\n');
define('JS_PRODUCTS_WEIGHT', '* El nuevo producto necesita un valor para el peso\n');
define('JS_PRODUCTS_QUANTITY', '* El nuevo producto necesita un valor para la cantidad\n');
define('JS_PRODUCTS_MODEL', '* El nuevo producto necesita un valor para el modelo\n');
define('JS_PRODUCTS_IMAGE', '* El nuevo producto necesita un valor para la imagen\n');

define('JS_SPECIALS_PRODUCTS_PRICE', '* Un nuevo precio debe ser aplicado para este producto\n');

define('JS_GENDER', '* El \'Género\' debe ser elegido.\n');
define('JS_FIRST_NAME', '* El \'Nombre\' debe tener almenos ' . ENTRY_FIRST_NAME_MIN_LENGTH . ' carácteres.\n');
define('JS_LAST_NAME', '* El \'Apellido\' debe tener almenos ' . ENTRY_LAST_NAME_MIN_LENGTH . ' carácteres.\n');
define('JS_DOB', '* La \'Fecha de Nacimiento\' debe estar en este formato: xx/xx/xxxx (mes/día/año).\n');
define('JS_EMAIL_ADDRESS', '* La \'dirección E-Mail\' debe tener almenos ' . ENTRY_EMAIL_ADDRESS_MIN_LENGTH . ' carácteres.\n');
define('JS_ADDRESS', '* El \'Domicilio\' debe tener almenos ' . ENTRY_STREET_ADDRESS_MIN_LENGTH . ' carácteres.\n');
define('JS_POST_CODE', '* El \'Código Postal\' debe tener almenos ' . ENTRY_POSTCODE_MIN_LENGTH . ' carácteres.\n');
define('JS_CITY', '* La \'Ciudad\' debe tener almenos ' . ENTRY_CITY_MIN_LENGTH . ' carácteres.\n');
define('JS_STATE', '* El \'País\' debe ser seleccionado.\n');
define('JS_STATE_SELECT', '-- Seleccione Abajo --');
define('JS_ZONE', '* El \'País\' debe ser seleccionado de la lista de páises.');
define('JS_COUNTRY', '* El \'País\' debe ser seleccionado.\n');
define('JS_TELEPHONE', '* El \'Número de Teléfono\' debe tener almenos ' . ENTRY_TELEPHONE_MIN_LENGTH . ' carácteres.\n');
define('JS_PASSWORD', '* La \'Contraseña\' y la \'Confirmación\' deben coincidir y tener almenos ' . ENTRY_PASSWORD_MIN_LENGTH . ' carácteres.\n');

define('JS_ORDER_DOES_NOT_EXIST', '¡El número de pedido %s no existe!');

define('CATEGORY_PERSONAL', 'Personal');
define('CATEGORY_ADDRESS', 'Dirección');
define('CATEGORY_CONTACT', 'Contacto');
define('CATEGORY_COMPANY', 'Compañía');
define('CATEGORY_OPTIONS', 'Opciones');

define('ENTRY_GENDER', 'Género:');
define('ENTRY_GENDER_ERROR', '&nbsp;<span class="errorText">requeridos</span>');
define('ENTRY_FIRST_NAME', 'Nombre:');
define('ENTRY_FIRST_NAME_ERROR', '&nbsp;<span class="errorText">min ' . ENTRY_FIRST_NAME_MIN_LENGTH . ' carácteres</span>');
define('ENTRY_LAST_NAME', 'Apellido:');
define('ENTRY_LAST_NAME_ERROR', '&nbsp;<span class="errorText">min ' . ENTRY_LAST_NAME_MIN_LENGTH . ' carácteres</span>');
define('ENTRY_DATE_OF_BIRTH', 'Fecha de Nacimiento:');
define('ENTRY_DATE_OF_BIRTH_ERROR', '&nbsp;<span class="errorText">(ej. 05/21/1970)</span>');
define('ENTRY_EMAIL_ADDRESS', 'Dirección E-Mail:');
define('ENTRY_EMAIL_ADDRESS_ERROR', '&nbsp;<span class="errorText">min ' . ENTRY_EMAIL_ADDRESS_MIN_LENGTH . ' carácteres</span>');
define('ENTRY_EMAIL_ADDRESS_CHECK_ERROR', '&nbsp;<span class="errorText">¡La dirección email no parece ser válida!</span>');
define('ENTRY_EMAIL_ADDRESS_ERROR_EXISTS', '&nbsp;<span class="errorText">¡Esta dirección de email ya existe!</span>');
define('ENTRY_COMPANY', 'Empresa:');
define('ENTRY_STREET_ADDRESS', 'Dirección:');
define('ENTRY_STREET_ADDRESS_ERROR', '&nbsp;<span class="errorText">min ' . ENTRY_STREET_ADDRESS_MIN_LENGTH . ' carácteres</span>');
define('ENTRY_SUBURB', 'Suburbio:');
define('ENTRY_POST_CODE', 'Código Postal:');
define('ENTRY_POST_CODE_ERROR', '&nbsp;<span class="errorText">min ' . ENTRY_POSTCODE_MIN_LENGTH . ' carácteres</span>');
define('ENTRY_CITY', 'Ciudad:');
define('ENTRY_CITY_ERROR', '&nbsp;<span class="errorText">min ' . ENTRY_CITY_MIN_LENGTH . ' carácteres</span>');
define('ENTRY_STATE', 'País:');
define('ENTRY_STATE_ERROR', '&nbsp;<span class="errorText">son requeridos</span>');
define('ENTRY_COUNTRY', 'País:');
define('ENTRY_COUNTRY_ERROR', 'Debes seleccionar almenos un país del menú despegable de países.');
define('ENTRY_TELEPHONE_NUMBER', 'Número de Teléfono:');
define('ENTRY_TELEPHONE_NUMBER_ERROR', '&nbsp;<span class="errorText">min ' . ENTRY_TELEPHONE_MIN_LENGTH . ' carácteres</span>');
define('ENTRY_FAX_NUMBER', 'Número del Fax:');
define('ENTRY_NEWSLETTER', 'Boletín de Noticias:');
define('ENTRY_NEWSLETTER_YES', 'Suscrito');
define('ENTRY_NEWSLETTER_NO', 'No Suscrito');

// images
define('IMAGE_ANI_SEND_EMAIL', 'Enviando E-Mail');
define('IMAGE_BACK', 'Volver');
define('IMAGE_BACKUP', 'Copia');
define('IMAGE_CANCEL', 'Cancelar');
define('IMAGE_CONFIRM', 'Confirmar');
define('IMAGE_COPY', 'Copiar');
define('IMAGE_COPY_TO', 'Copiar A');
define('IMAGE_DETAILS', 'Detalles');
define('IMAGE_DELETE', 'Eliminar');
define('IMAGE_EDIT', 'Editar');
define('IMAGE_EMAIL', 'Email');
define('IMAGE_EXPORT', 'Exportar');
define('IMAGE_ICON_STATUS_GREEN', 'Activo');
define('IMAGE_ICON_STATUS_GREEN_LIGHT', 'Poner Activo');
define('IMAGE_ICON_STATUS_RED', 'Inactivo');
define('IMAGE_ICON_STATUS_RED_LIGHT', 'Poner Inactivo');
define('IMAGE_ICON_INFO', 'Info');
define('IMAGE_INSERT', 'Insertar');
define('IMAGE_LOCK', 'Bloquear');
define('IMAGE_MODULE_INSTALL', 'Instalar Módulo');
define('IMAGE_MODULE_REMOVE', 'Eliminar Módulo');
define('IMAGE_MOVE', 'Mover');
define('IMAGE_NEW_BANNER', 'Nuevo Banner');
define('IMAGE_NEW_CATEGORY', 'Nueva Categoría');
define('IMAGE_NEW_COUNTRY', 'Nuevo País');
define('IMAGE_NEW_CURRENCY', 'Nueva Divisa');
define('IMAGE_NEW_FILE', 'Nuevo Archivo');
define('IMAGE_NEW_FOLDER', 'Nuevo Directorio');
define('IMAGE_NEW_LANGUAGE', 'Nuevo Idioma');
define('IMAGE_NEW_NEWSLETTER', 'Nuevo Boletín');
define('IMAGE_NEW_PRODUCT', 'Nuevo Producto');
define('IMAGE_NEW_TAX_CLASS', 'Nueva Clase de Tasa');
define('IMAGE_NEW_TAX_RATE', 'Nuevo Valor de Tasa');
define('IMAGE_NEW_TAX_ZONE', 'Nueva Zona de Tasa');
define('IMAGE_NEW_ZONE', 'Nueva Zona');
define('IMAGE_ORDERS', 'Pedidos');
define('IMAGE_ORDERS_INVOICE', 'Facturas');
define('IMAGE_ORDERS_PACKINGSLIP', 'Empaquetado');
define('IMAGE_PREVIEW', 'Vista Previa');
define('IMAGE_RESTORE', 'Restaurar');
define('IMAGE_RESET', 'Reiniciar');
define('IMAGE_SAVE', 'Guardar');
define('IMAGE_SEARCH', 'Buscar');
define('IMAGE_SELECT', 'Seleccionar');
define('IMAGE_SEND', 'Enviar');
define('IMAGE_SEND_EMAIL', 'Enviar Email');
define('IMAGE_UNLOCK', 'Desbloquear');
define('IMAGE_UPDATE', 'Actualizar');
define('IMAGE_UPDATE_CURRENCIES', 'Actualizar Valor de Intercambio');
define('IMAGE_UPLOAD', 'Subir');
define('TPV_VIRTUAL_IMAGE_VOID', 'Anular');

define('ICON_CROSS', 'Falso');
define('ICON_CURRENT_FOLDER', 'Directorio Actual');
define('ICON_DELETE', 'Eliminar');
define('ICON_ERROR', 'Error');
define('ICON_FILE', 'Archivo');
define('ICON_FILE_DOWNLOAD', 'Descargar');
define('ICON_FOLDER', 'Directorio');
define('ICON_LOCKED', 'Bloqueado');
define('ICON_PREVIOUS_LEVEL', 'Nivel Anterior');
define('ICON_PREVIEW', 'Vista Previa');
define('ICON_STATISTICS', 'Estadísticas');
define('ICON_SUCCESS', 'Éxito');
define('ICON_TICK', 'Verdadero');
define('ICON_UNLOCKED', 'Desbloqueado');
define('ICON_WARNING', 'Aviso');

// constants for use in tep_prev_next_display function
define('TEXT_RESULT_PAGE', 'Page %s of %d');
define('TEXT_DISPLAY_NUMBER_OF_BANNERS', 'Mostrando <strong>%d</strong> a <strong>%d</strong> (de <strong>%d</strong> banners)');
define('TEXT_DISPLAY_NUMBER_OF_COUNTRIES', 'Mostrando <strong>%d</strong> a <strong>%d</strong> (de <strong>%d</strong> países)');
define('TEXT_DISPLAY_NUMBER_OF_CUSTOMERS', 'Mostrando <strong>%d</strong> a <strong>%d</strong> (de <strong>%d</strong> clientes)');
define('TEXT_DISPLAY_NUMBER_OF_CURRENCIES', 'Mostrando <strong>%d</strong> a <strong>%d</strong> (de <strong>%d</strong> divisas)');
define('TEXT_DISPLAY_NUMBER_OF_ENTRIES', 'Mostrando <strong>%d</strong> a <strong>%d</strong> (de <strong>%d</strong> entradas)');
define('TEXT_DISPLAY_NUMBER_OF_LANGUAGES', 'Mostrando <strong>%d</strong> a <strong>%d</strong> (de <strong>%d</strong> idiomas)');
define('TEXT_DISPLAY_NUMBER_OF_MANUFACTURERS', 'Mostrando <strong>%d</strong> a <strong>%d</strong> (de <strong>%d</strong> fabricantes)');
define('TEXT_DISPLAY_NUMBER_OF_NEWSLETTERS', 'Mostrando <strong>%d</strong> a <strong>%d</strong> (de <strong>%d</strong> boletines de noticias)');
define('TEXT_DISPLAY_NUMBER_OF_ORDERS', 'Mostrando <strong>%d</strong> a <strong>%d</strong> (de <strong>%d</strong> pedidos)');
define('TEXT_DISPLAY_NUMBER_OF_ORDERS_STATUS', 'Mostrando <strong>%d</strong> a <strong>%d</strong> (de <strong>%d</strong> estados de pedidos)');
define('TEXT_DISPLAY_NUMBER_OF_PRODUCTS', 'Mostrando <strong>%d</strong> a <strong>%d</strong> (de <strong>%d</strong> productos)');
define('TEXT_DISPLAY_NUMBER_OF_PRODUCTS_EXPECTED', 'Mostrando <strong>%d</strong> a <strong>%d</strong> (de <strong>%d</strong> productos esperados)');
define('TEXT_DISPLAY_NUMBER_OF_REVIEWS', 'Mostrando <strong>%d</strong> a <strong>%d</strong> (de <strong>%d</strong> comentarios de productos)');
define('TEXT_DISPLAY_NUMBER_OF_SPECIALS', 'Mostrando <strong>%d</strong> a <strong>%d</strong> (de <strong>%d</strong> productos especiales)');
define('TEXT_DISPLAY_NUMBER_OF_TAX_CLASSES', 'Mostrando <strong>%d</strong> a <strong>%d</strong> (de <strong>%d</strong> tipos de tasas)');
define('TEXT_DISPLAY_NUMBER_OF_TAX_ZONES', 'Mostrando <strong>%d</strong> a <strong>%d</strong> (de <strong>%d</strong> zonas de tasas)');
define('TEXT_DISPLAY_NUMBER_OF_TAX_RATES', 'Mostrando <strong>%d</strong> a <strong>%d</strong> (de <strong>%d</strong> valores de tasas)');
define('TEXT_DISPLAY_NUMBER_OF_ZONES', 'Mostrando <strong>%d</strong> a <strong>%d</strong> (de <strong>%d</strong> zonas)');

define('PREVNEXT_BUTTON_PREV', '&lt;&lt;');
define('PREVNEXT_BUTTON_NEXT', '&gt;&gt;');

define('TEXT_DEFAULT', 'predeterminado');
define('TEXT_SET_DEFAULT', 'Marcar como predeterminado');
define('TEXT_FIELD_REQUIRED', '&nbsp;<span class="fieldRequired">* Requerido</span>');

define('TEXT_CACHE_CATEGORIES', 'Sección de Categorías');
define('TEXT_CACHE_MANUFACTURERS', 'Sección de Fabricantes');
define('TEXT_CACHE_ALSO_PURCHASED', 'Módulo de productos comprados');

define('TEXT_NONE', '--none--');
define('TEXT_TOP', 'Top');

define('ERROR_DESTINATION_DOES_NOT_EXIST', 'Error: El destino no existe.');
define('ERROR_DESTINATION_NOT_WRITEABLE', 'Error: El destino no es modificable.');
define('ERROR_FILE_NOT_SAVED', 'Error: Archivo todavía no guardado.');
define('ERROR_FILETYPE_NOT_ALLOWED', 'Error: La subida del tipo de este archivo no está permitida.');
define('SUCCESS_FILE_SAVED_SUCCESSFULLY', 'Éxito: La subida del archivo ha sido guardada con éxito.');
define('WARNING_NO_FILE_UPLOADED', 'Aviso: Ningún archivo ha sido subido.');

?>
